/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <fakemeta>
#include <fakemeta_util>
#include <cstrike>


#define PLUGIN "Admin God"
#define VERSION "0.1.0"
#define AUTHOR "PomanoB"

#define PLAYER_MODEL "terminator"

#define W_MODEL "models/molotov/w_molotov.mdl"
#define V_MODEL "models/molotov/v_molotov.mdl"
#define P_MODEL "models/molotov/p_molotov.mdl"

new const g_required_radiotype[] = "#Fire_in_the_hole"

new bool:g_IsOn[33]

new g_pAllocModel, g_vAllocModel

new g_trail

new g_cvar_ricochet, g_cvar_speed

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	g_cvar_ricochet = register_cvar("admin_god_ricochet","1")
	g_cvar_speed = register_cvar("admin_god_speed","700.0")
	
	register_event("ResetHUD", "resetHud", "b")
	
	register_clcmd("say /god", "turn_god")
	
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1")
	
	register_forward(FM_SetModel, "fw_set_model") 
	register_forward(FM_Touch,"fw_touch")
	
	register_message(get_user_msgid("TextMsg"), "message_text")
	
	register_message(get_user_msgid("SendAudio"), "SendAudio")
	
	g_pAllocModel = engfunc(EngFunc_AllocString, P_MODEL);
	g_vAllocModel = engfunc(EngFunc_AllocString, V_MODEL);
}
public plugin_precache() 
{
	new modelpath[100]
	formatex(modelpath,sizeof(modelpath)-1,"models/player/%s/%s.mdl",PLAYER_MODEL,PLAYER_MODEL)
	precache_model(W_MODEL)
	precache_model(P_MODEL)
	precache_model(V_MODEL)
	precache_model(modelpath)
	
	g_trail = precache_model("sprites/smoke.spr")
}

public fw_set_model(entity, const model[]) 
{
	if(!pev_valid(entity)) 
		return FMRES_IGNORED 
	static owner
	owner = pev(entity, pev_owner)
	if(!owner || model[7] != 'w' || model[8] != '_'  ) 
		return FMRES_IGNORED 
	
	if (model[9]=='h' && model[10]=='e' && g_IsOn[owner])
	{
		engfunc(EngFunc_SetModel, entity, W_MODEL)
		set_pev(entity,pev_nextthink,99999.0)
		
		//================ se7h - Grenade Launcher ===========
		static Float:pVelocity[3], Float:nVelocity[3], Float:pAim[3], Float:spd
		pev(owner, pev_velocity, pVelocity)
		engfunc(EngFunc_GetAimVector, owner, spd, pAim)
		xs_vec_mul_scalar(pAim, 1000.0, nVelocity)
		xs_vec_add(nVelocity, pVelocity, nVelocity)
		
		if(vector_length(nVelocity) > 2000.0)
			xs_vec_mul_scalar(pAim, 2000.0, nVelocity)
		
		set_pev(entity, pev_velocity, nVelocity)
		//====================================================
		
		set_task(0.1,"giveGun",owner)
		set_task(5.0,"removeGrenade",9578+entity)
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMFOLLOW)
		write_short(entity)
		write_short(g_trail)
		write_byte(10)
		write_byte(5)
		write_byte(0)
		write_byte(255)
		write_byte(255)
		write_byte(192)
		message_end()
		
		
		return FMRES_SUPERCEDE
	}
	return FMRES_IGNORED 
	
}
public fw_touch(ptr, ptd)
{
	static ptrc[32], ptdc[32], owner
	pev(ptr, pev_classname, ptrc, 31)
	if (!pev_valid(ptd))
		return FMRES_IGNORED
	pev(ptd, pev_classname, ptdc, 31)
	if(equal(ptrc, "grenade"))
	{	
		owner = pev(ptr,pev_owner)
		if (g_IsOn[owner] && equal(ptdc, "player"))
		{
			user_kill(ptd)
			engfunc(EngFunc_RemoveEntity,ptr)
		}
		else if (g_IsOn[owner] && !get_pcvar_num(g_cvar_ricochet))
			engfunc(EngFunc_RemoveEntity,ptr)
	}
		

	return FMRES_IGNORED
}
public resetHud(id)
{
	if(g_IsOn[id] && (get_user_flags(id)&ADMIN_RCON))
	{
		cs_set_user_model(id,PLAYER_MODEL)
		set_task(0.2,"stripAndGive",id+4698)
	}

	return PLUGIN_CONTINUE
	
}
public turn_god(id)
{
	if (!(get_user_flags(id)&ADMIN_RCON))
		return PLUGIN_CONTINUE
	
	if (!is_user_alive(id))
	{
		client_print(id,print_chat,"You must be alive!")
		return PLUGIN_HANDLED
	}
	g_IsOn[id] = !g_IsOn[id]
	fm_set_user_noclip(id,(g_IsOn[id] ? 1 : 0))
	fm_set_user_godmode(id,(g_IsOn[id] ? 1 : 0))
	client_print(id,print_chat,"God Mode is now %s!",(g_IsOn[id] ? "enabled" : "disabled"))
	if (g_IsOn[id])
	{
		fm_strip_user_weapons(id)
		fm_give_item(id,"weapon_hegrenade")
		fm_set_user_maxspeed(id,get_pcvar_float(g_cvar_speed))
		cs_set_user_model(id,PLAYER_MODEL)
	}
	else if (is_user_alive(id))
	{
		cs_set_user_model(id,(cs_get_user_team(id) == CS_TEAM_CT ? "gign" : "guerilla"))
		fm_strip_user_weapons(id)
		fm_give_item(id,"weapon_knife")
	}
	return PLUGIN_HANDLED
}
public client_connect(id)
{
	g_IsOn[id]=false
}
public client_disconnect(id)
{
	g_IsOn[id]=false
}
public Event_CurWeapon(id)
{
	if (!is_user_alive(id) || !g_IsOn[id])
		return PLUGIN_CONTINUE
	new weapon = read_data(2)
	if(weapon == CSW_HEGRENADE)
	{
		set_pev(id,pev_viewmodel,g_vAllocModel)
		set_pev(id,pev_weaponmodel,g_pAllocModel)
		fm_set_user_maxspeed(id,get_pcvar_float(g_cvar_speed))
	}
	return PLUGIN_CONTINUE
}
public giveGun(id)
{
	fm_give_item(id,"weapon_hegrenade")
}
public removeGrenade(entity)
{
	if (pev_valid(entity-9578))
		engfunc(EngFunc_RemoveEntity,entity-9578)
}
public stripAndGive(id)
{
	fm_set_user_noclip(id-4698,1)
	fm_set_user_godmode(id-4698,1)
	fm_set_user_maxspeed(id-4698,get_pcvar_float(g_cvar_speed))
	fm_strip_user_weapons(id-4698)
	fm_give_item(id-4698,"weapon_hegrenade")
}
public message_text(msgid, dest, id)
{
	if (get_msg_args() != 5 || get_msg_argtype(5) != ARG_STRING)
		return PLUGIN_CONTINUE
	
	static arg[32]
	get_msg_arg_string(5, arg, sizeof arg - 1)
	if (!equal(arg, g_required_radiotype))
		return PLUGIN_CONTINUE
		
	get_msg_arg_string(2, arg, sizeof arg - 1)
	new caller = str_to_num(arg)
	if (!is_user_alive(caller))
		return PLUGIN_CONTINUE
		
	if (!g_IsOn[caller])	
		return PLUGIN_CONTINUE
		
	return PLUGIN_HANDLED
}
public SendAudio()
{
	// - !MRAD_FIREINHOL
	static AudioCode[64]
	static sid 
	sid = get_msg_arg_int(1)
		
	get_msg_arg_string(2,AudioCode,63)
	
	if (equal(AudioCode,"%!MRAD_FIREINHOLE") && g_IsOn[sid])
		return PLUGIN_HANDLED
	
	return PLUGIN_CONTINUE
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
